// OBJ SPT Pointer demo by DanB

#include "libgccvb.h"

#include "chObjDemo.h"
#include "mpObjDemo.h"


static HWORD objNumbers[] = {
//	X	L/RON & P	Y	Pal/HFlp/VFlp/Char
	120,	0xC000,		100,	3,	// 0
	130,	0xC000,		100,	4,	// 1
	140,	0xC000,		100,	5,	// 2
	150,	0xC000,		100,	6,	// 3
	160,	0xC000,		100,	7,	// 4
	170,	0xC000,		100,	8,	// 5
	180,	0xC000,		100,	9,	// 6
	190,	0xC000,		100,	10,	// 7
	200,	0xC000,		100,	11,	// 8
	210,	0xC000,		100,	12,	// 9
	220,	0xC000,		100,	13,	// 10
	230,	0xC000,		100,	14,	// 11
	240,	0xC000,		100,	15,	// 12
	250,	0xC000,		100,	16,	// 13
	260,	0xC000,		100,	17,	// 14
	270,	0xC000,		100,	18,	// 15
};

int main()
{
	int marker = 3;
	int pressed = 0;
	int value[4] = {0,0,0,15};
	int worlds = 4;

	vbDisplayOn();
	vbDisplayShow();

	copymem((void*)CharSeg0,(void*)CHOBJDEMO,75*16);
	copymem((void*)BGMap(0),(void*)MPOBJDEMO,274*2);
	copymem((void*)OAMBase, (void*)objNumbers, 128);
	
	vbSetWorld(31,(WRLD_LON|WRLD_RON|WRLD_OBJ),0,0,0,0,0,0,0,0);
	vbSetWorld(30,(WRLD_LON|WRLD_RON),88,0,94,56,0,0,199,15);	//first folder
	vbSetWorld(29,(WRLD_LON|WRLD_RON|WRLD_OBJ),0,0,0,0,0,0,0,0);
	vbSetWorld(28,(WRLD_LON|WRLD_RON),88,-1,96,56,0,0,199,15);	//second folder
	vbSetWorld(27,(WRLD_LON|WRLD_RON|WRLD_OBJ),0,0,0,0,0,0,0,0);
	vbSetWorld(26,(WRLD_LON|WRLD_RON),88,-2,98,56,0,0,199,15);	//third folder
	vbSetWorld(25,(WRLD_LON|WRLD_RON|WRLD_OBJ),0,0,0,0,0,0,0,0);
	vbSetWorld(24,(WRLD_LON|WRLD_RON),8,0,180,0,0,0,31,31);		//VIPREGS...
	vbSetWorld(23,(WRLD_LON|WRLD_RON),40,0,180,176,0,16,7,7);
	vbSetWorld(22,(WRLD_LON|WRLD_RON),40,0,188,56,0,16,7,7);
	vbSetWorld(21,(WRLD_LON|WRLD_RON),40,0,196,56,0,16,7,7);
	vbSetWorld(20,(WRLD_LON|WRLD_RON),40,0,204,56,0,16,7,7);
	vbSetWorld(19,(WRLD_LON|WRLD_RON),32,-2,180,32,0,0,23,7);	//marker
	vbSetWorld(18,(WRLD_LON|WRLD_RON),287,0,196,144,0,24,71,7);	//# of Worlds
	vbSetWorld(17,(WRLD_LON|WRLD_RON),360,0,196,88,0,16,7,7);
	vbSetWorld(16,(WRLD_LON|WRLD_RON),140,0,8,32,0,24,106,15);	//Demo by...
	WORLD_HEAD(15, WRLD_END);

	VIP_REGS[SPT3] = 15;
	VIP_REGS[SPT2] = 0;
	VIP_REGS[SPT1] = 0;
	VIP_REGS[SPT0] = 0;

	while(1)
	{
		if (!(vbReadPad() & K_PADS)) pressed = 0;
		if ((vbReadPad() & K_LU || vbReadPad() & K_LD) && pressed == 0) { //move marker
			if (vbReadPad() & K_LU)
				marker++;
			if (vbReadPad() & K_LD)
				marker--;
			if (marker > 3) marker -= 4;
			if (marker < 0) marker += 4;
			WORLD_GSET(19,32,-2,204-marker*8);
			pressed = 1;
		}
		
		if ((vbReadPad() & K_LL || vbReadPad() & K_LR) && pressed == 0) { //change SPT values
			if ((vbReadPad() & K_LL) && value[marker] > -3)
				value[marker]--;
			if ((vbReadPad() & K_LR) && value[marker] < 19)
				value[marker]++;
			WORLD_MSET(20+marker,56+value[marker]*8,0,16);
			VIP_REGS[SPT0+marker] = value[marker];
			pressed = 1;
		}

		if ((vbReadPad() & K_RU || vbReadPad() & K_RD) && pressed == 0) { //change # of OBJ Worlds
			if ((vbReadPad() & K_RU) && worlds < 4)
				worlds++;
			if ((vbReadPad() & K_RD) && worlds > 0)
				worlds--;
			WORLD_MSET(17,56+worlds*8,0,16);
			
			switch (worlds) {			
				case 0: WORLD_HEAD(31, 0);
					break;
				case 1: WORLD_HEAD(31,(WRLD_LON|WRLD_RON|WRLD_OBJ));
					WORLD_HEAD(29, 0);
					break;
				case 2: WORLD_HEAD(29,(WRLD_LON|WRLD_RON|WRLD_OBJ));
					WORLD_HEAD(27, 0);
					break;
				case 3: WORLD_HEAD(27,(WRLD_LON|WRLD_RON|WRLD_OBJ));
					WORLD_HEAD(25, 0);
					break;
				case 4: WORLD_HEAD(25,(WRLD_LON|WRLD_RON|WRLD_OBJ));
			}
			pressed = 1;
		}
	}
}
